<template>
  <q-toolbar class="bg-primary text-white shadow-2">
    <q-toolbar-title role="heading" aria-level="2">Linkroles
      <q-badge align="top" outline v-if="linkroles_filtered">
        {{ linkroles_filtered.length }}
      </q-badge>
      <q-badge align="top" outline v-else>0</q-badge>

    </q-toolbar-title>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value" autofocus>
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
        <template v-slot:append>
          <q-icon name="close" @click="search_value = ''" class="cursor-pointer"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>
  <div class="scroll_list" :key="language_switch">
    <q-list bordered>
      <q-item clickable v-ripple
              v-for="linkrole in linkroles_filtered"
              v-bind:id="linkrole.role_uri"
              v-bind:key="linkrole.role_uri"
              active-class="active"
              :to="{name: 'linkrole_detail', params: {linkrole_id: linkrole.id, linkrole_role_uri: linkrole.role_uri}, hash: '#' + linkrole.role_uri}">
        <q-item-section>
          <q-item-label>
            <span v-html="show_label(linkrole)"></span>
            <q-badge color="blue-8"
                     :label="linkrole.order"
                     v-if="linkrole.order"
                     floating
                     outline
                     class="on-left q-mt-sm"></q-badge>
          </q-item-label>
        </q-item-section>
      </q-item>
      <q-inner-loading :showing="typeof this.linkroles=='undefined'">
        <q-circular-progress
          class="text-blue-grey"
          indeterminate
          size="50px"
          :thickness="0.22"
          v-if="typeof this.linkroles=='undefined'"></q-circular-progress>
      </q-inner-loading>

    </q-list>
  </div>

</template>

<script>
import {api} from 'boot/axios'
import SharedMethods from "components/SharedMethods";

export default {
  name: "linkroleList",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
    this.fetchData()
  },
  props: {
    dts_name: String,
    nt_version: String
  },
  data() {
    return {
      linkroles: undefined,
      current_linkrole: Object,
      search_value: undefined,
      language_switch: undefined
    }
  },
  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/linkroles", {params: {nt_version: this.nt_version, full: 0}})
        .then(response => {
          this.linkroles = response.data
          if (this.linkroles.length && this.$route.fullPath.endsWith('/linkroles')) {
            this.$router.push({name: 'linkrole_detail', replace: true,
              params: {linkrole_id: this.linkroles[0].id, linkrole_role_uri: this.linkroles[0].role_uri},
            hash: "#" + this.linkroles[0].role_uri})
          } else {
            this.$nextTick(() => {
              this.scroll_to_active()
            })
          }
        })
        .catch((error) => {
          this.references = []
        })
    },
    getConcept: function (event) {
      this.current_linkrole = event.target
    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    }
  },
  computed: {
    linkroles_filtered() {
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        return this.linkroles.filter(
          linkrole => this.get_label(linkrole)
            && this.get_label(linkrole).toLowerCase().includes(this.search_value.toLowerCase())
        )
      } else {
        return this.linkroles
      }
    }
  },
  watch: {
    "$route.path": function () {
      // Nexttick wraps this and executes the function _after_ the DOM has been redrawn
      // And we query DOM elements here, so we should wait for the DOM
      this.$nextTick(() => {
        this.scroll_to_active()
      })
      console.log("Changed?")
    },
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  }
}
</script>

<style scoped lang="scss">
.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}

.scroll_list .active .q-badge {
  color: white !important;
}

.active {
  background: $primary;
  color: white;
  opacity: 0.9;
}
</style>
